Index: /LMDZ4/trunk/libf/phylmd/oasis.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/oasis.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/oasis.F	(revision 541)
@@ -2,5 +2,4 @@
 ! $Header$
 !
-C $Id$
 C****
 C
@@ -43,5 +42,6 @@
 #include "mpiclim.h"
 c
-#include "oasis.h"      ! contains the name of communication technique. Here
+#include "oasis.h"      
+                        ! contains the name of communication technique. Here
                         ! cchan=CLIM only is possible.
 c			! ctype=MPI2
@@ -557,4 +557,19 @@
       END
 
+      SUBROUTINE halte
+      print *, 'Attention dans oasis.F, halte est non defini'
+      RETURN
+      END
+
+      SUBROUTINE locread
+      print *, 'Attention dans oasis.F, locread est non defini'
+      RETURN
+      END
+
+      SUBROUTINE locwrite
+      print *, 'Attention dans oasis.F, locwrite est non defini'
+      RETURN
+      END
+
       SUBROUTINE pipe_model_define
       print*,'Attention dans oasis.F, pipe_model_define est non defini'
@@ -577,4 +592,54 @@
       END
 
+      SUBROUTINE clim_stepi
+      print *, 'Attention dans oasis.F, clim_stepi est non defini'
+      RETURN
+      END
+
+      SUBROUTINE clim_start
+      print *, 'Attention dans oasis.F, clim_start est non defini'
+      RETURN
+      END
+
+      SUBROUTINE clim_import
+      print *, 'Attention dans oasis.F, clim_import est non defini'
+      RETURN
+      END
+
+      SUBROUTINE clim_export
+      print *, 'Attention dans oasis.F, clim_export est non defini'
+      RETURN
+      END
+
+      SUBROUTINE clim_init
+      print *, 'Attention dans oasis.F, clim_init est non defini'
+      RETURN
+      END
+
+      SUBROUTINE clim_define
+      print *, 'Attention dans oasis.F, clim_define est non defini'
+      RETURN
+      END
+
+      SUBROUTINE clim_quit
+      print *, 'Attention dans oasis.F, clim_quit est non defini'
+      RETURN
+      END
+
+      SUBROUTINE svipc_write
+      print *, 'Attention dans oasis.F, svipc_write est non defini'
+      RETURN
+      END
+
+      SUBROUTINE svipc_close
+      print *, 'Attention dans oasis.F, svipc_close est non defini'
+      RETURN
+      END
+
+      SUBROUTINE svipc_read
+      print *, 'Attention dans oasis.F, svipc_read est non defini'
+      RETURN
+      END
+
       SUBROUTINE quitcpl
       print *, 'Attention dans oasis.F, quitcpl est non defini'
Index: /LMDZ4/trunk/libf/phylmd/phyetat0.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/phyetat0.F	(revision 541)
@@ -665,31 +665,4 @@
            ENDDO
          ENDDO
-c          IF (nsrf.GT.99) THEN
-c            PRINT*, "Trop de sous-mailles"
-c            CALL abort
-c          ENDIF
-c          WRITE(str2,'(i2.2)') nsrf
-c          ierr = NF_INQ_VARID (nid, "ALBLW"//str2, nvarid)
-c           IF (ierr.NE.NF_NOERR) THEN
-c             PRINT*, "phyetat0: Le champ <ALBLW"//str2//"> est absent"
-c             CALL abort
-c          ENDIF
-c#ifdef NC_DOUBLE
-c           ierr = NF_GET_VAR_DOUBLE(nid, nvarid, alblw(1,nsrf))
-c#else
-c           ierr = NF_GET_VAR_REAL(nid, nvarid, alblw(1,nsrf))
-c#endif
-c          IF (ierr.NE.NF_NOERR) THEN
-c            PRINT*, "phyetat0: Lecture echouee pour <ALBLW"//str2//">"
-c            CALL abort
-c          ENDIF
-c          xmin = 1.0E+20
-c          xmax = -1.0E+20
-c          DO i = 1, klon
-c             xmin = MIN(alblw(i,nsrf),xmin)
-c             xmax = MAX(alblw(i,nsrf),xmax)
-c          ENDDO
-c          PRINT*,'Albedo du sol ALBLW**:', nsrf, xmin, xmax
-c        ENDDO
       ELSE
          PRINT*, 'phyetat0: Le champ <ALBLW> est present'
Index: /LMDZ4/trunk/libf/phylmd/phyredem.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/phyredem.F	(revision 541)
@@ -3,5 +3,4 @@
 !
 c
-cIM   SUBROUTINE phyredem (fichnom,dtime,radpas,co2_ppm,solaire,
       SUBROUTINE phyredem (fichnom,dtime,radpas,
      .           rlat,rlon, pctsrf,tsol,tsoil,deltat,qsurf,qsol,snow,
@@ -30,6 +29,4 @@
       INTEGER radpas
       REAL rlat(klon), rlon(klon)
-cIM   REAL co2_ppm
-cIM   REAL solaire
       REAL tsol(klon,nbsrf)
       REAL tsoil(klon,nsoilmx,nbsrf)
Index: /LMDZ4/trunk/libf/phylmd/physiq.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/physiq.F	(revision 541)
@@ -2,6 +2,4 @@
 ! $Header$
 !
-C
-c $Header$
 c
       SUBROUTINE physiq (nlon,nlev,nqmax,
@@ -88,4 +86,5 @@
 #include "advtrac.h"
 #include "iniprint.h"
+#include "thermcell.h"
 c======================================================================
       LOGICAL ok_cvl  ! pour activer le nouveau driver pour convection KE
@@ -157,4 +156,10 @@
       PARAMETER (ok_region=.FALSE.)
 c======================================================================
+c     pour phsystoke avec thermiques
+      REAL fm_therm(klon,klev+1)
+      REAL entr_therm(klon,klev)
+      real q2(klon,klev+1,nbsrf)
+      save q2
+c======================================================================
 c
       INTEGER ivap          ! indice de traceurs pour vapeur d'eau
@@ -594,7 +599,7 @@
       REAL zxffonte(klon), zxfqcalving(klon)
 
-      LOGICAL offline           ! Controle du stockage ds "physique"
-      PARAMETER (offline=.false.)
-      INTEGER physid
+c$$$      LOGICAL offline           ! Controle du stockage ds "physique"
+c$$$      PARAMETER (offline=.false.)
+c$$$      INTEGER physid
       REAL pfrac_impa(klon,klev)! Produits des coefs lessivage impaction
       save pfrac_impa
@@ -807,4 +812,5 @@
       REAL d_t_lsc(klon,klev),d_q_lsc(klon,klev),d_ql_lsc(klon,klev)
       REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
+      REAL d_u_ajs(klon,klev), d_v_ajs(klon,klev)
       REAL d_t_eva(klon,klev),d_q_eva(klon,klev)
       REAL rneb(klon,klev)
@@ -1034,6 +1040,6 @@
      .                  iflag_cldcon,ratqsbas,ratqshaut, if_ebil,
      .                  ok_ade, ok_aie, 
-     .                  bl95_b0, bl95_b1)
-cIM  .                  , RI0)
+     .                  bl95_b0, bl95_b1,
+     .                  iflag_thermals,nsplit_thermals)
 
 c
@@ -1053,4 +1059,6 @@
      .       run_off_lic_0)
 
+c   ATTENTION : il faudra a terme relire q2 dans l'etat initial
+         q2(:,:,:)=1.e-8
 c
          radpas = NINT( 86400./dtime/nbapp_rad)
@@ -1508,4 +1516,5 @@
      s            d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_ts,
      s            fluxt,fluxq,fluxu,fluxv,cdragh,cdragm,
+     s            q2,
      s            dsens, devap,
      s            ycoefh,yu1,yv1, t2m, q2m, u10m, v10m,
@@ -1850,11 +1859,42 @@
 c Appeler l'ajustement sec
 c
-      CALL ajsec(paprs, pplay, t_seri, q_seri, d_t_ajs, d_q_ajs)
-      DO k = 1, klev
-      DO i = 1, klon
-         t_seri(i,k) = t_seri(i,k) + d_t_ajs(i,k)
-         q_seri(i,k) = q_seri(i,k) + d_q_ajs(i,k)
-      ENDDO
-      ENDDO
+c===================================================================
+c Convection seche (thermiques ou ajustement)
+c===================================================================
+c
+      d_t_ajs(:,:)=0.
+      d_u_ajs(:,:)=0.
+      d_v_ajs(:,:)=0.
+      d_q_ajs(:,:)=0.
+      fm_therm(:,:)=0.
+      entr_therm(:,:)=0.
+c
+      print*,'AVANT LA CONVECTION SECHE , iflag_thermals='
+     s   ,iflag_thermals,'   nsplit_thermals=',nsplit_thermals
+      if(iflag_thermals.lt.0) then
+c  Rien
+c  ====
+         print*,'pas de convection'
+      else if(iflag_thermals.eq.0) then
+
+c  Ajustement sec
+c  ==============
+         print*,'ajsec'
+         CALL ajsec(paprs, pplay, t_seri,q_seri, d_t_ajs, d_q_ajs)
+         t_seri(:,:) = t_seri(:,:) + d_t_ajs(:,:)
+         q_seri(:,:) = q_seri(:,:) + d_q_ajs(:,:)
+      else
+c  Thermiques
+c  ==========
+         print*,'JUSTE AVANT , iflag_thermals='
+     s   ,iflag_thermals,'   nsplit_thermals=',nsplit_thermals
+         call calltherm(pdtphys
+     s      ,pplay,paprs,pphi
+     s      ,u_seri,v_seri,t_seri,q_seri
+     s      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs
+     s      ,fm_therm,entr_therm)
+      endif
+c
+c===================================================================
 c
       IF (if_ebil.ge.2) THEN 
@@ -2573,6 +2613,6 @@
      I                   u,v,t,paprs,pplay,
      I                   pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
-     I                   ycoefh,yu1,yv1,ftsol,pctsrf,rlat,
-     I                   frac_impa, frac_nucl,
+     I                   ycoefh,fm_therm,entr_therm,yu1,yv1,ftsol,
+     I                   pctsrf,rlat,frac_impa, frac_nucl,
      I                   rlon,presnivs,pphis,pphi,
      I                   albsol,
@@ -2589,7 +2629,9 @@
       IF (offline) THEN
 
+         print*,'Attention on met a 0 les thermiques pour phystoke'
 	 call phystokenc (
      I                   nlon,nlev,pdtphys,rlon,rlat,
      I                   t,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+     I                   fm_therm,entr_therm,
      I                   ycoefh,yu1,yv1,ftsol,pctsrf,
      I                   frac_impa, frac_nucl,
Index: /LMDZ4/trunk/libf/phylmd/phystokenc.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/phystokenc.F	(revision 540)
+++ /LMDZ4/trunk/libf/phylmd/phystokenc.F	(revision 541)
@@ -7,6 +7,7 @@
      I                   nlon,nlev,pdtphys,rlon,rlat,
      I                   pt,pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
+     I                   pfm_therm,pentr_therm,
      I                   pcoefh,yu1,yv1,ftsol,pctsrf,
-     I                   pfrac_impa,pfrac_nucl,
+     I                   frac_impa,frac_nucl,
      I                   pphis,paire,dtime,itap)
       USE ioipsl
@@ -40,5 +41,7 @@
       real pdtphys ! pas d'integration pour la physique (seconde)
 c
-      integer physid, itap,ndex(1)
+      integer physid, itap
+      save physid
+      integer ndex2d(iim*(jjm+1)),ndex3d(iim*(jjm+1)*klev)
 
 c   convection:
@@ -51,5 +54,5 @@
       REAL pen_d(klon,klev) ! flux entraine dans le panache descendant
       REAL pde_d(klon,klev) ! flux detraine dans le panache descendant
-	REAL pt(klon,klev)
+	real pt(klon,klev),t(klon,klev)
 c
       REAL rlon(klon), rlat(klon), dtime
@@ -62,10 +65,18 @@
       REAL yv1(klon)
       REAL yu1(klon),pphis(klon),paire(klon)
+
+c   Les Thermiques : (Abderr 25 11 02)
+c   ---------------
+      REAL pfm_therm(klon,klev+1)
+	real fm_therm1(klon,klev)
+      REAL pentr_therm(klon,klev)
+      REAL entr_therm(klon,klev)
+      REAL fm_therm(klon,klev)
 c
 c   Lessivage:
 c   ----------
 c
-      REAL pfrac_impa(klon,klev)
-      REAL pfrac_nucl(klon,klev)
+      REAL frac_impa(klon,klev)
+      REAL frac_nucl(klon,klev)
 c
 c Arguments necessaires pour les sources et puits de traceur
@@ -84,8 +95,4 @@
       REAL de_d(klon,klev) ! flux detraine dans le panache descendant
       REAL coefh(klon,klev) ! flux detraine dans le panache descendant
-	REAL t(klon,klev)
-      REAL frac_impa(klon,klev)
-      REAL frac_nucl(klon,klev)
-      REAL rain(klon)
 
       REAL pyu1(klon),pyv1(klon)
@@ -98,8 +105,9 @@
       integer iadvtr,irec
       real zmin,zmax
-
+      logical ok_sync
+ 
       save t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,dtcum
+	save fm_therm,entr_therm
       save iadvtr,irec
-      save frac_impa,frac_nucl,rain
       save pyu1,pyv1,pftsol,ppsrf
 
@@ -109,4 +117,6 @@
 c======================================================================
 
+      ok_sync = .true.
+	print*,'Dans phystokenc.F'
       print*,'iadvtr= ',iadvtr
       print*,'istphy= ',istphy
@@ -120,19 +130,19 @@
 	write(*,*) 'apres initphysto ds phystokenc' 
 
-       ndex(1) = 0
-         i=itap 
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
-         CALL histwrite(physid,"phis",i,zx_tmp_2d,iim*(jjm+1),ndex)
-c
-         i=itap
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
-         CALL histwrite(physid,"aire",i,zx_tmp_2d,iim*(jjm+1),ndex)
 	
       ENDIF
 c
+      ndex2d = 0
+      ndex3d = 0
+      i=itap 
+      CALL gr_fi_ecrit(1,klon,iim,jjm+1,pphis,zx_tmp_2d)
+      CALL histwrite(physid,"phis",i,zx_tmp_2d,iim*(jjm+1),ndex2d)
+c
+      i=itap
+      CALL gr_fi_ecrit(1,klon,iim,jjm+1,paire,zx_tmp_2d)
+      CALL histwrite(physid,"aire",i,zx_tmp_2d,iim*(jjm+1),ndex2d)
+
       iadvtr=iadvtr+1
 c
-c
-c   reinitialisation des champs cumules
       if (mod(iadvtr,istphy).eq.1.or.istphy.eq.1) then
 	print*,'reinitialisation des champs cumules 
@@ -140,6 +150,4 @@
          do k=1,klev
             do i=1,klon
-               frac_impa(i,k)=1.
-               frac_nucl(i,k)=1.
                mfu(i,k)=0.
                mfd(i,k)=0.
@@ -149,9 +157,10 @@
                de_d(i,k)=0.
                coefh(i,k)=0.
-		t(i,k)=0.
-            enddo
-         enddo
-         do i=1,klon
-            rain(i)=0.
+                t(i,k)=0.
+		fm_therm(i,k)=0.
+               entr_therm(i,k)=0.
+            enddo
+         enddo
+         do i=1,klon
             pyv1(i)=0.
             pyu1(i)=0.
@@ -169,6 +178,217 @@
       do k=1,klev
          do i=1,klon
-            frac_impa(i,k)=frac_impa(i,k)*pfrac_impa(i,k)
-            frac_nucl(i,k)=frac_nucl(i,k)*pfrac_nucl(i,k)
+            mfu(i,k)=mfu(i,k)+pmfu(i,k)*pdtphys
+            mfd(i,k)=mfd(i,k)+pmfd(i,k)*pdtphys
+            en_u(i,k)=en_u(i,k)+pen_u(i,k)*pdtphys
+            de_u(i,k)=de_u(i,k)+pde_u(i,k)*pdtphys
+            en_d(i,k)=en_d(i,k)+pen_d(i,k)*pdtphys
+            de_d(i,k)=de_d(i,k)+pde_d(i,k)*pdtphys
+            coefh(i,k)=coefh(i,k)+pcoefh(i,k)*pdtphys
+                t(i,k)=t(i,k)+pt(i,k)*pdtphys
+       fm_therm(i,k)=fm_therm(i,k)+pfm_therm(i,k)*pdtphys
+       entr_therm(i,k)=entr_therm(i,k)+pentr_therm(i,k)*pdtphys
+         enddo
+      enddo
+         do i=1,klon
+            pyv1(i)=pyv1(i)+yv1(i)*pdtphys
+            pyu1(i)=pyu1(i)+yu1(i)*pdtphys
+         end do
+         do k=1,nbsrf
+             do i=1,klon
+               pftsol(i,k)=pftsol(i,k)+ftsol(i,k)*pdtphys
+               ppsrf(i,k)=ppsrf(i,k)+pctsrf(i,k)*pdtphys
+            enddo
+         enddo
+
+      dtcum=dtcum+pdtphys
+
+      IF(mod(iadvtr,istphy).eq.0) THEN 
+c
+c   normalisation par le temps cumule
+         do k=1,klev
+            do i=1,klon
+               mfu(i,k)=mfu(i,k)/dtcum
+               mfd(i,k)=mfd(i,k)/dtcum
+               en_u(i,k)=en_u(i,k)/dtcum
+               de_u(i,k)=de_u(i,k)/dtcum
+               en_d(i,k)=en_d(i,k)/dtcum
+               de_d(i,k)=de_d(i,k)/dtcum
+               coefh(i,k)=coefh(i,k)/dtcum
+c Unitel a enlever
+	      t(i,k)=t(i,k)/dtcum	
+               fm_therm(i,k)=fm_therm(i,k)/dtcum
+	       entr_therm(i,k)=entr_therm(i,k)/dtcum
+            enddo
+         enddo
+         do i=1,klon
+            pyv1(i)=pyv1(i)/dtcum
+            pyu1(i)=pyu1(i)/dtcum
+         end do
+         do k=1,nbsrf
+             do i=1,klon
+               pftsol(i,k)=pftsol(i,k)/dtcum
+               pftsol1(i) = pftsol(i,1)
+               pftsol2(i) = pftsol(i,2)
+               pftsol3(i) = pftsol(i,3)
+               pftsol4(i) = pftsol(i,4)
+
+               ppsrf(i,k)=ppsrf(i,k)/dtcum
+               ppsrf1(i) = ppsrf(i,1)
+               ppsrf2(i) = ppsrf(i,2)
+               ppsrf3(i) = ppsrf(i,3)
+               ppsrf4(i) = ppsrf(i,4)
+
+            enddo
+         enddo
+c
+c   ecriture des champs
+c
+         irec=irec+1
+
+ccccc
+         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, t, zx_tmp_3d)
+         CALL histwrite(physid,"t",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+
+         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfu, zx_tmp_3d)
+      CALL histwrite(physid,"mfu",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+	CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfd, zx_tmp_3d)
+      CALL histwrite(physid,"mfd",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_u, zx_tmp_3d)
+      CALL histwrite(physid,"en_u",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_u, zx_tmp_3d)
+      CALL histwrite(physid,"de_u",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_d, zx_tmp_3d)
+      CALL histwrite(physid,"en_d",itap,zx_tmp_3d,
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_d, zx_tmp_3d)       
+      CALL histwrite(physid,"de_d",itap,zx_tmp_3d,    
+     .                                   iim*(jjm+1)*klev,ndex3d)
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, coefh, zx_tmp_3d)         
+      CALL histwrite(physid,"coefh",itap,zx_tmp_3d,    
+     .                                   iim*(jjm+1)*klev,ndex3d)	
+
+c ajou...
+	do k=1,klev
+           do i=1,klon
+	 fm_therm1(i,k)=fm_therm(i,k)	
+	   enddo
+	enddo
+
+      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, fm_therm1, zx_tmp_3d)
+      CALL histwrite(physid,"fm_th",itap,zx_tmp_3d,
+     .                                 iim*(jjm+1)*klev,ndex3d)
+c
+      CALL gr_fi_ecrit(klev,klon,iim,jjm+1, entr_therm, zx_tmp_3d)
+      CALL histwrite(physid,"en_th",itap,zx_tmp_3d,
+     .                                iim*(jjm+1)*klev,ndex3d)
+cccc
+       CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_impa,zx_tmp_3d)
+        CALL histwrite(physid,"frac_impa",itap,zx_tmp_3d,
+     .  iim*(jjm+1)*klev,ndex3d)
+
+        CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_nucl,zx_tmp_3d)
+        CALL histwrite(physid,"frac_nucl",itap,zx_tmp_3d,
+     .  iim*(jjm+1)*klev,ndex3d)
+ 
+        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyu1,zx_tmp_2d)
+      CALL histwrite(physid,"pyu1",itap,zx_tmp_2d,iim*(jjm+1),
+     .                                                ndex2d)
+	
+	CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyv1,zx_tmp_2d)
+      CALL histwrite(physid,"pyv1",itap,zx_tmp_2d,iim*(jjm+1)
+     .                                                ,ndex2d)
+	
+	CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol1, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol1",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol2, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol2",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+          CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol3, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol3",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol4, zx_tmp_2d)
+      CALL histwrite(physid,"ftsol4",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf1, zx_tmp_2d)
+      CALL histwrite(physid,"psrf1",itap,zx_tmp_2d,   
+     .                                   iim*(jjm+1),ndex2d)
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf2, zx_tmp_2d)
+      CALL histwrite(physid,"psrf2",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf3, zx_tmp_2d)
+      CALL histwrite(physid,"psrf3",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf4, zx_tmp_2d)
+      CALL histwrite(physid,"psrf4",itap,zx_tmp_2d,
+     .                                   iim*(jjm+1),ndex2d)
+
+      if (ok_sync) call histsync(physid)
+c     if (ok_sync) call histsync
+	
+c
+cAA Test sur la valeur des coefficients de lessivage 
+c
+         zmin=1e33
+         zmax=-1e33
+         do k=1,klev
+            do i=1,klon
+                  zmax=max(zmax,frac_nucl(i,k))
+                  zmin=min(zmin,frac_nucl(i,k))
+            enddo
+         enddo
+         Print*,'------ coefs de lessivage (min et max) --------'
+         Print*,'facteur de nucleation ',zmin,zmax
+         zmin=1e33
+         zmax=-1e33
+         do k=1,klev
+            do i=1,klon
+                  zmax=max(zmax,frac_impa(i,k))
+                  zmin=min(zmin,frac_impa(i,k))
+            enddo
+         enddo
+         Print*,'facteur d impaction ',zmin,zmax
+
+      ENDIF 
+
+c   reinitialisation des champs cumules
+	go to 768
+      if (mod(iadvtr,istphy).eq.1) then
+         do k=1,klev
+            do i=1,klon
+               mfu(i,k)=0.
+               mfd(i,k)=0.
+               en_u(i,k)=0.
+               de_u(i,k)=0.
+               en_d(i,k)=0.
+               de_d(i,k)=0.
+               coefh(i,k)=0.
+	       t(i,k)=0.
+               fm_therm(i,k)=0.
+	       entr_therm(i,k)=0.
+            enddo
+         enddo
+         do i=1,klon
+            pyv1(i)=0.
+            pyu1(i)=0.
+         end do
+         do k=1,nbsrf
+             do i=1,klon
+               pftsol(i,k)=0.
+               ppsrf(i,k)=0.
+            enddo
+         enddo
+
+         dtcum=0.
+      endif
+
+      do k=1,klev
+         do i=1,klon
             mfu(i,k)=mfu(i,k)+pmfu(i,k)*pdtphys
             mfd(i,k)=mfd(i,k)+pmfd(i,k)*pdtphys
@@ -179,4 +399,6 @@
             coefh(i,k)=coefh(i,k)+pcoefh(i,k)*pdtphys
 		t(i,k)=t(i,k)+pt(i,k)*pdtphys
+       fm_therm(i,k)=fm_therm(i,k)+pfm_therm(i,k)*pdtphys
+       entr_therm(i,k)=entr_therm(i,k)+pentr_therm(i,k)*pdtphys
          enddo
       enddo
@@ -193,151 +415,5 @@
 
       dtcum=dtcum+pdtphys
-c
-      IF(mod(iadvtr,istphy).eq.0) THEN
-c
-c   normalisation par le temps cumule
-         do k=1,klev
-            do i=1,klon
-c              frac_impa=frac_impa : c'est la fraction cumulee qu'on stoke
-c              frac_nucl=frac_nucl : c'est la fraction cumulee qu'on stoke
-               mfu(i,k)=mfu(i,k)/dtcum
-               mfd(i,k)=mfd(i,k)/dtcum
-               en_u(i,k)=en_u(i,k)/dtcum
-               de_u(i,k)=de_u(i,k)/dtcum
-               en_d(i,k)=en_d(i,k)/dtcum
-               de_d(i,k)=de_d(i,k)/dtcum
-               coefh(i,k)=coefh(i,k)/dtcum
-		t(i,k)=t(i,k)/dtcum
-            enddo
-         enddo
-         do i=1,klon
-            rain(i)=rain(i)/dtcum
-            pyv1(i)=pyv1(i)/dtcum
-            pyu1(i)=pyu1(i)/dtcum
-         end do
-c modif abderr 23 11 00         do k=1,nbsrf
-             do i=1,klon
-	      do k=1,nbsrf
-               pftsol(i,k)=pftsol(i,k)/dtcum
-	       ppsrf(i,k)=ppsrf(i,k)/dtcum
-	      enddo
-               pftsol1(i) = pftsol(i,1)
-               pftsol2(i) = pftsol(i,2)
-               pftsol3(i) = pftsol(i,3)
-               pftsol4(i) = pftsol(i,4)
-
-c               ppsrf(i,k)=ppsrf(i,k)/dtcum
-               ppsrf1(i) = ppsrf(i,1)
-               ppsrf2(i) = ppsrf(i,2)
-               ppsrf3(i) = ppsrf(i,3)
-               ppsrf4(i) = ppsrf(i,4)
-
-            enddo
-c         enddo
-c
-c   ecriture des champs
-c
-         irec=irec+1
-
-ccccc
-      print*,'AVANT ECRITURE'
-         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, t, zx_tmp_3d)
-         CALL histwrite(physid,"t",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-      print*,'APRES ECRITURE'
-
-         CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfu, zx_tmp_3d)
-      CALL histwrite(physid,"mfu",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, mfd, zx_tmp_3d)
-      CALL histwrite(physid,"mfd",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_u, zx_tmp_3d)
-      CALL histwrite(physid,"en_u",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_u, zx_tmp_3d)
-      CALL histwrite(physid,"de_u",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, en_d, zx_tmp_3d)
-      CALL histwrite(physid,"en_d",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, de_d, zx_tmp_3d)
-      CALL histwrite(physid,"de_d",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1, coefh, zx_tmp_3d)
-      CALL histwrite(physid,"coefh",itap,zx_tmp_3d,
-     .                                   iim*(jjm+1)*klev,ndex)
-cccc
-       CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_impa,zx_tmp_3d)
-        CALL histwrite(physid,"frac_impa",itap,zx_tmp_3d,
-     .  iim*(jjm+1)*klev,ndex)
-
-        CALL gr_fi_ecrit(klev,klon,iim,jjm+1,frac_nucl,zx_tmp_3d)
-        CALL histwrite(physid,"frac_nucl",itap,zx_tmp_3d,
-     .  iim*(jjm+1)*klev,ndex)
-
-        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyu1,zx_tmp_2d)
-      CALL histwrite(physid,"pyu1",itap,zx_tmp_2d,iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1, klon,iim,jjm+1, pyv1,zx_tmp_2d)
-      CALL histwrite(physid,"pyv1",itap,zx_tmp_2d,iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol1, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol1",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol2, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol2",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-          CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol3, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol3",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-c
-         CALL gr_fi_ecrit(1,klon,iim,jjm+1, pftsol4, zx_tmp_2d)
-      CALL histwrite(physid,"ftsol4",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, rain, zx_tmp_2d)
-      CALL histwrite(physid,"rain",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf1, zx_tmp_2d)
-      CALL histwrite(physid,"psrf1",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf2, zx_tmp_2d)
-      CALL histwrite(physid,"psrf2",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf3, zx_tmp_2d)
-      CALL histwrite(physid,"psrf3",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-        CALL gr_fi_ecrit(1,klon,iim,jjm+1, ppsrf4, zx_tmp_2d)
-      CALL histwrite(physid,"psrf4",itap,zx_tmp_2d,
-     .                                   iim*(jjm+1),ndex)
-
-c
-cAA Test sur la valeur des coefficients de lessivage
-c
-         zmin=1e33
-         zmax=-1e33
-         do k=1,klev
-            do i=1,klon
-                  zmax=max(zmax,frac_nucl(i,k))
-                  zmin=min(zmin,frac_nucl(i,k))
-            enddo
-         enddo
-         Print*,'------ coefs de lessivage (min et max) --------'
-         Print*,'facteur de nucleation ',zmin,zmax
-         zmin=1e33
-         zmax=-1e33
-         do k=1,klev
-            do i=1,klon
-                  zmax=max(zmax,frac_impa(i,k))
-                  zmin=min(zmin,frac_impa(i,k))
-            enddo
-         enddo
-         Print*,'facteur d impaction ',zmin,zmax
-
-      ENDIF
-
+768   continue
 
       RETURN
